Reinforcement BillOfMaterial: Difference between revisions

From FreeCAD Documentation
(Marked this version for translation)
No edit summary
Line 6: Line 6:
|[[Arch_Rebar|Rebar]]
|[[Arch_Rebar|Rebar]]
|[[Arch_Floor|Floor]]
|[[Arch_Floor|Floor]]
|[[Reinforcement_Workbench|Reinforcement]]
|[[Arch_Module|Arch]]
|IconL=Arch_Rebar.svg
|IconL=Arch_Rebar.svg
|IconC=Workbench_Arch.svg
|IconC=Reinforcement_Workbench.svg
|IconR=Arch_Floor.svg
|IconR=Arch_Floor.svg
}}
}}
Line 16: Line 16:
{{GuiCommand
{{GuiCommand
|Name=Arch Rebar BOM
|Name=Arch Rebar BOM
|MenuLocation=ArchRebar
|MenuLocation=ReinforcementBillOfMaterial
|Workbenches=[[Arch Workbench|Arch]], [[BIM Workbench|BIM]]
|Workbenches=[[Reinforcement Workbench|Reinforcement]], [[Arch Workbench|Arch]], [[BIM Workbench|BIM]]
|SeeAlso=[[Arch Rebar|Arch Rebar]], [[Reinforcement Addon|Reinforcement Addon]]
|SeeAlso=[[Arch Rebar|Arch Rebar]]
|Version=0.19
|Version=0.19
}}
}}
Line 28: Line 28:


<!--T:5-->
<!--T:5-->
This command is part of the [[Reinforcement Addon|Reinforcement Addon]], an [[External workbenches|external workbench]] that can be installed with the [[Image:AddonManager.svg|24px]] [[Addon Manager|Addon Manager]] via the {{MenuCommand|Tools → Addon manager → Reinforcement}} menu.
This command is part of the [[Reinforcement Workbench|Reinforcement Workbench]], an [[External workbenches|external workbench]] that can be installed with the [[Image:AddonManager.svg|24px]] [[Addon Manager|Addon Manager]] via the {{MenuCommand|Tools → Addon manager → Reinforcement}} menu.


</translate>
</translate>
Line 299: Line 299:
|[[Arch_Rebar|Rebar]]
|[[Arch_Rebar|Rebar]]
|[[Arch_Floor|Floor]]
|[[Arch_Floor|Floor]]
|[[Reinforcement_Workbench|Reinforcement]]
|[[Arch_Module|Arch]]
|IconL=Arch_Rebar.svg
|IconL=Arch_Rebar.svg
|IconC=Workbench_Arch.svg
|IconC=Reinforcement_Workbench.svg
|IconR=Arch_Floor.svg
|IconR=Arch_Floor.svg
}}
}}
</translate>
</translate>
{{Arch Tools navi{{#translation:}}}}
[[Category:External Command Reference{{#translation:}}]]
[[Category:External Command Reference{{#translation:}}]]
[[Category:Reinforcement{{#translation:}}]]
[[Category:Reinforcement{{#translation:}}]]

Revision as of 14:07, 2 September 2020


Arch Rebar BOM

Menu location
Reinforcement → BillOfMaterial
Workbenches
Reinforcement, Arch, BIM
Default shortcut
None
Introduced in version
0.19
See also
Arch Rebar

Description

The Bill Of Material tool allows the user to create bill of material of reinforcing bars.

This command is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager via the Tools → Addon manager → Reinforcement menu.

Bill Of Material of reinforcing bars

Usage

1. Select Arch Rebar objects you want to include in Bill Of Material. Or select Arch Structure objects to include Arch Rebar objects hosted by that into Bill Of Material. If nothing is selected, then Bill Of Material will be generated for all Arch Rebar and Rebar2 objects present in model.

2. Then select Bill Of Material from the rebar tools.

3. A dialog box will pop-out on screen as shown below.

Dialog Box for the Arch Rebar BOM tool

4. Modify data to suit your requirements.

5. To edit Bill Of Material SVG configurations, click on Edit SVG Configurations. A dialog box will pop-out as shown below.

Dialog Box for the Arch Rebar BOM SVG configuration editing

6. Modify Bill Of Material SVG configurations and then click on OK to apply changes.

7. Click OK or Apply to generate Bill Of Material for rebars.

8. Click Cancel to exit the dialog box.

Properties

General:

  • DataColumn Headers: A dictionary with column_data as key and tuple (column_display_header, column_sequence) as value.
  • DataColumn Units: A dictionary with keys: "Diameter", "RebarLength", "RebarsTotalLength" and their corresponding units as value.
  • DataDiameter Weight Map: A dictionary with diameter as key and corresponding weight as value.
  • DataRebar Length Type: Rebar Length Type specifies the type of rebar length used for BOM calculations i.e. "RealLength" or "LengthWithSharpEdges".
  • DataRebar Objects: A list of ArchRebar and/or rebar2 and/or structures (to select ArchRebar in that structure) objects.

SVG:

  • DataFont Family: Font Family of text in BOM SVG.
  • DataFont Filename: Font filename corresponding to font family required in console mode.
  • DataFont Size: Font size in mm.
  • DataColumn Width: Width of each column in BOM SVG table.
  • DataRow Height: Height of each row in BOM SVG table.
  • DataLeft Offset: Left offset of BOM SVG table.
  • DataTop Offset: Top offset of BOM SVG table.
  • DataMinimum Right Offset: Minimum right offset of BOM SVG table.
  • DataMinimum Bottom Offset: Minimum bottom offset of BOM SVG table.
  • DataMaximum Width: Maximum width of BOM SVG table.
  • DataMaximum Height: Maximum height of BOM SVG table.
  • DataTemplate File: Template svg file for BOM SVG.
  • DataOutput File: BOM SVG Output file.

Scripting

See also: Arch API, Reinforcement API and FreeCAD Scripting Basics.

The Bill Of Material tool can be used in macros and from the Python console by using the following function:

Create Bill Of Material Spreadsheet

bom_spreadhseet = makeBillOfMaterial(
    column_headers=None,
    column_units=None,
    dia_weight_map=None,
    rebar_length_type=None,
    rebar_objects=None,
    obj_name="RebarBillOfMaterial",
)
  • Creates a RebarBillOfMaterial spreadsheet object for given rebar_objects.
    • If rebar_objects list is empty, then RebarBillOfMaterial spreadsheet will be created all rebars in a model.
  • column_headers is a dictionary with keys: "Mark", "RebarsCount", "Diameter", "RebarLength", "RebarsTotalLength" and values are tuple of column_header and their sequence number.
   Example: {
                "Mark": ("Mark", 1),
                "RebarsCount": ("No. of Rebars", 2),
                "Diameter": ("Diameter in mm", 3),
                "RebarLength": ("Length in m/piece", 4),
                "RebarsTotalLength": ("Total Length in m", 5),
            }
            set column sequence number to 0 to hide column.
  • column_units is a dictionary with keys: "Diameter", "RebarLength", "RebarsTotalLength" and their corresponding units as value.
   Example: {
                "Diameter": "mm",
                "RebarLength": "m",
                "RebarsTotalLength": "m",
            }
  • dia_weight_map is a dictionary with diameter as key and corresponding weight as value.
   Syntax: {
                6: FreeCAD.Units.Quantity("0.222 kg/m"),
                8: FreeCAD.Units.Quantity("0.395 kg/m"),
                10: FreeCAD.Units.Quantity("0.617 kg/m"),
                12: FreeCAD.Units.Quantity("0.888 kg/m"),
                ...,
            }
  • rebar_length_type specifies the type of rebar length used for BOM calculations; it can be "RealLength" or "LengthWithSharpEdges".
  • rebar_objects is a list of ArchRebar and/or rebar2 and/or structures (to select ArchRebar in that structure) objects.

Example

import FreeCAD, Draft, Arch
from ColumnReinforcement import TwoTiesSixRebars
from BillOfMaterial import BillOfMaterial_Spreadsheet


# It doesn't work if the structure is not based on a face
# Structure = Arch.makeStructure(length=1000, width=400, height=400)

Rect = Draft.makeRectangle(400, 400)
Structure1 = Arch.makeStructure(Rect, height=1600)
Structure1.ViewObject.Transparency = 80
Structure2 = Arch.makeStructure(Rect, height=1600)
Structure2.ViewObject.Transparency = 80
Structure2.Placement = FreeCAD.Placement(FreeCAD.Vector(1000, 0, 0), FreeCAD.Rotation(FreeCAD.Vector(0, 0, 1), 0))
FreeCAD.ActiveDocument.recompute()

# Create Straight Rebars
RebarGroup = TwoTiesSixRebars.makeTwoTiesSixRebars(
    l_cover_of_ties=40,        
    r_cover_of_ties=40,
    t_cover_of_ties=40,
    b_cover_of_ties=40,
    offset_of_ties=100,
    bent_angle_of_ties=135,
    extension_factor_of_ties=2,
    dia_of_ties=8,
    number_spacing_check=True,
    number_spacing_value=10,
    dia_of_main_rebars=16,
    t_offset_of_rebars=40,
    b_offset_of_rebars=40,
    main_rebars_type="StraightRebar",
    hook_orientation="Top Inside",
    hook_extend_along="x-axis",
    l_rebar_rounding=None,
    hook_extension=None,
    ties_sequence=("Tie1", "Tie2"),
    structure=Structure1,
    facename="Face6",
)


# Create LShaped Rebars with hook along x-axis
RebarGroup = TwoTiesSixRebars.makeTwoTiesSixRebars(
    l_cover_of_ties=40,
    r_cover_of_ties=40,
    t_cover_of_ties=40,
    b_cover_of_ties=40,
    offset_of_ties=100,
    bent_angle_of_ties=135,
    extension_factor_of_ties=2,
    dia_of_ties=8,
    number_spacing_check=True,
    number_spacing_value=10,
    dia_of_main_rebars=16,
    t_offset_of_rebars=-40,
    b_offset_of_rebars=-40,
    main_rebars_type="LShapeRebar",
    hook_orientation="Top Outside",
    hook_extend_along="x-axis",
    l_rebar_rounding=2,
    hook_extension=40,
    ties_sequence=("Tie1", "Tie2"),
    structure=Structure2,
    facename="Face6",
)

COLUMN_UNITS = {
    "Diameter": "mm",
    "RebarLength": "m",
    "RebarsTotalLength": "m",
}

COLUMN_HEADERS = {
    "Mark": ("Mark", 1),
    "RebarsCount": ("No. of Rebars", 2),
    "Diameter": ("Diameter in " + COLUMN_UNITS["Diameter"], 3),
    "RebarLength": ("Length in " + COLUMN_UNITS["RebarLength"] + "/piece", 4),
    "RebarsTotalLength": ("Total Length in " + COLUMN_UNITS["RebarsTotalLength"], 5),
}

DIA_WEIGHT_MAP = {
    6: FreeCAD.Units.Quantity("0.222 kg/m"),
    8: FreeCAD.Units.Quantity("0.395 kg/m"),
    10: FreeCAD.Units.Quantity("0.617 kg/m"),
    12: FreeCAD.Units.Quantity("0.888 kg/m"),
    14: FreeCAD.Units.Quantity("1.206 kg/m"),
    16: FreeCAD.Units.Quantity("1.578 kg/m"),
    18: FreeCAD.Units.Quantity("2.000 kg/m"),
    20: FreeCAD.Units.Quantity("2.466 kg/m"),
    22: FreeCAD.Units.Quantity("2.980 kg/m"),
    25: FreeCAD.Units.Quantity("3.854 kg/m"),
    28: FreeCAD.Units.Quantity("4.830 kg/m"),
    32: FreeCAD.Units.Quantity("6.313 kg/m"),
    36: FreeCAD.Units.Quantity("7.990 kg/m"),
    40: FreeCAD.Units.Quantity("9.864 kg/m"),
    45: FreeCAD.Units.Quantity("12.490 kg/m"),
    50: FreeCAD.Units.Quantity("15.410 kg/m"),
}

# To create Bill Of Material Spreadsheet for all rebars in a model

BillOfMaterial_Spreadsheet.makeBillOfMaterial(
    column_headers=COLUMN_HEADERS,
    column_units=COLUMN_UNITS,
    dia_weight_map=DIA_WEIGHT_MAP,
    rebar_length_type="RealLength",
)

# To create Bill Of Material Spreadsheet for rebars in Structure1

BillOfMaterial_Spreadsheet.makeBillOfMaterial(
    column_headers=COLUMN_HEADERS,
    column_units=COLUMN_UNITS,
    dia_weight_map=DIA_WEIGHT_MAP,
    rebar_length_type="LengthWithSharpEdges",
    rebar_objects=[Structure1],
)